/*
 * SPI_Falsh.C
 *
 *  Created on: 20231115
 *      Author: Administrator
 */

#include "sys.h"

/******************** ΪSPI1ʵ ********************/

// ʼSPI1
void SPI1_Init(void) 
{
    // ʼʱ
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA | RCC_APB2Periph_SPI1, ENABLE);

    // ʼGPIO
    GPIO_InitTypeDef GPIO_InitStructure = { 0 };

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_2;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(GPIOA, &GPIO_InitStructure);

    GPIO_SetBits(GPIOA, GPIO_Pin_2); // CSߵƽѡFlashоƬ

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_5 | GPIO_Pin_7;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(GPIOA, &GPIO_InitStructure);

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_6;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
    GPIO_Init(GPIOA, &GPIO_InitStructure);

    // ʼSPI1
    SPI_InitTypeDef SPI_InitStructure = { 0 };

    SPI_InitStructure.SPI_Direction = SPI_Direction_2Lines_FullDuplex; // ȫ˫ģʽ
    SPI_InitStructure.SPI_Mode = SPI_Mode_Master;                      // Ϊ
    SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b;                  // 8bit
    SPI_InitStructure.SPI_CPOL = SPI_CPOL_High;                        // ʱӲͨѶʱߵƽ
    SPI_InitStructure.SPI_CPHA = SPI_CPHA_2Edge;                       // ڵڶԵв൱ʹMode3
    SPI_InitStructure.SPI_NSS = SPI_NSS_Soft;                          // Ƭѡֶ
    SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_4; // SPIʱԴ4Ƶ
    SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB;                 // ʱ߱ǰ
    SPI_InitStructure.SPI_CRCPolynomial = 7;
    SPI_Init(SPI1, &SPI_InitStructure);                                // ʼSPI1

    SPI_Cmd(SPI1, ENABLE);                                             // SPI1
}

// ܶSPIĶдǷװһģҪѡдд
// SPIʱҪע⣬ʱȻǴӻ͵ģʱӻ
// ʱҪͨдݣɣʱź
// SPI1_Write_Read(0x00) ʾͨдһֽʱӴӶմӻһֽ
u8 SPI1_ReadWriteByte(u8 TxData) 
{
    u8 i = 0;
    while(SPI_I2S_GetFlagStatus(SPI1, SPI_I2S_FLAG_TXE) == RESET) 
    { // ȴSPI1д
        i++; if(i > 200) return 0;
    }
    SPI_I2S_SendData(SPI1, TxData); // д

    i = 0;
    while(SPI_I2S_GetFlagStatus(SPI1, SPI_I2S_FLAG_RXNE) == RESET) 
    { // ȴSPI1ɶ
        i++; if(i > 200) return 0;
    }
    return SPI_I2S_ReceiveData(SPI1); // 
}
// Ҳã溯ʵʹʱֶƬѡźţܻ߼ҪһЩ
// ҪעעڷʱƬѡźŲҪǰˣ
// ʹʱʹ߼ԣֶӸʱʱƬѡź
// SPI_I2S_SendDataͻĴдݣ鵱ǰǷΪգ
// SPI_I2S_ReceiveDataӽջĴдݣ鵱ǰǷΪգ

/******************** ΪFalshʵ ********************/

// ״̬Ĵ
// BIT7  6   5   4   3   2   1   0
// SPR   RV  TB  BP2 BP1 BP0 WEL BUSY
u8 SPI_Flash_ReadSR(void) 
{
    u8 byte = 0;
    GPIO_WriteBit(GPIOA, GPIO_Pin_2, 0);    // ѡоƬ
    SPI1_ReadWriteByte(W25X_ReadStatusReg); // д
    byte = SPI1_ReadWriteByte(0x00);        // 
    GPIO_WriteBit(GPIOA, GPIO_Pin_2, 1);    // ͷоƬ
    return byte;
}

// д״̬Ĵ
void SPI_FLASH_Write_SR(u8 sr) 
{
    GPIO_WriteBit(GPIOA, GPIO_Pin_2, 0);     // ѡоƬ
    SPI1_ReadWriteByte(W25X_WriteStatusReg); // д
    SPI1_ReadWriteByte(sr);                  // д
    GPIO_WriteBit(GPIOA, GPIO_Pin_2, 1);     // ͷоƬ
}

// ȴFlash
void SPI_Flash_Wait_Busy(void) 
{
    while((SPI_Flash_ReadSR() & 0x01) == 0x01) 
    { 
    	
    }
}

// ʹд
void SPI_FLASH_Write_Enable(void) 
{
    GPIO_WriteBit(GPIOA, GPIO_Pin_2, 0);  // ѡоƬ
    SPI1_ReadWriteByte(W25X_WriteEnable); // д
    GPIO_WriteBit(GPIOA, GPIO_Pin_2, 1);  // ͷоƬ
}

// ʧд
void SPI_FLASH_Write_Disable(void) 
{
    GPIO_WriteBit(GPIOA, GPIO_Pin_2, 0);   // ѡоƬ
    SPI1_ReadWriteByte(W25X_WriteDisable); // д
    GPIO_WriteBit(GPIOA, GPIO_Pin_2, 1);   // ͷоƬ
}

// ȡоƬID
u16 SPI_Flash_ReadID(void) 
{
    GPIO_WriteBit(GPIOA, GPIO_Pin_2, 0);       // ѡоƬ
    SPI1_ReadWriteByte(W25X_ManufactDeviceID); // д
    SPI1_ReadWriteByte(0x00);                  // ͨݲʱӵȴݿɶ
    SPI1_ReadWriteByte(0x00);                  // ͬ
    SPI1_ReadWriteByte(0x00);                  // ͬ
    u16 Temp = 0;
    Temp |= SPI1_ReadWriteByte(0xFF) << 8;     // 
    Temp |= SPI1_ReadWriteByte(0xFF);          // ͬ
    GPIO_WriteBit(GPIOA, GPIO_Pin_2, 1);       // ͷоƬ
    return Temp;
}

// 
void SPI_Flash_Erase_Sector(u32 Dst_Addr) 
{
    SPI_FLASH_Write_Enable();                   // ʹд
    SPI_Flash_Wait_Busy();                      // ȴ
    GPIO_WriteBit(GPIOA, GPIO_Pin_2, 0);        // ѡоƬ
    SPI1_ReadWriteByte(W25X_SectorErase);       // 
    Dst_Addr *= 4096;                           // ÿСΪ4k
    SPI1_ReadWriteByte((u8)((Dst_Addr) >> 16)); // дַ
    SPI1_ReadWriteByte((u8)((Dst_Addr) >> 8));  // ͬ
    SPI1_ReadWriteByte((u8)Dst_Addr);           // ͬ
    GPIO_WriteBit(GPIOA, GPIO_Pin_2, 1);        // ͷоƬ
    SPI_Flash_Wait_Busy();                      // ȴ
}

// ȡ
void SPI_Flash_Read(u8 *pBuffer, u32 ReadAddr, u16 size) 
{
    GPIO_WriteBit(GPIOA, GPIO_Pin_2, 0);        // ѡоƬ
    SPI1_ReadWriteByte(W25X_ReadData);          // д
    SPI1_ReadWriteByte((u8)((ReadAddr) >> 16)); // дַ
    SPI1_ReadWriteByte((u8)((ReadAddr) >> 8));  // ͬ
    SPI1_ReadWriteByte((u8)ReadAddr);
    for(u16 i = 0; i < size; i++) 
    {
        pBuffer[i] = SPI1_ReadWriteByte(0x00);  // 
    }
    GPIO_WriteBit(GPIOA, GPIO_Pin_2, 1);        // ͷоƬ
}

// ҳʽд
void SPI_Flash_Write_Page(u8 *pBuffer, u32 WriteAddr, u16 size) 
{
    SPI_FLASH_Write_Enable();                    // ʹд
    GPIO_WriteBit(GPIOA, GPIO_Pin_2, 0);         // ѡоƬ
    SPI1_ReadWriteByte(W25X_PageProgram);        // д
    SPI1_ReadWriteByte((u8)((WriteAddr) >> 16)); // дַ
    SPI1_ReadWriteByte((u8)((WriteAddr) >> 8));  // ͬ
    SPI1_ReadWriteByte((u8)WriteAddr);           // ͬ
    for(u16 i = 0; i < size; i++) 
    {
        SPI1_ReadWriteByte(pBuffer[i]);          // д
    }
    GPIO_WriteBit(GPIOA, GPIO_Pin_2, 1);         // ͷоƬ
    SPI_Flash_Wait_Busy();                       // ȴ
}

// дݣдǰҪȲ
void SPI_Flash_Write_NoCheck(u8 *pBuffer, u32 WriteAddr, u16 size) 
{
    // һֻдһҳ256ֽ
    u16 pageremain = 256 - WriteAddr % 256;
    if(size <= pageremain) pageremain = size;
    while(1) 
    {
        SPI_Flash_Write_Page(pBuffer, WriteAddr, pageremain);
        if(size == pageremain) 
        { 
        	break; 
        }
        else 
        {
            pBuffer += pageremain;
            WriteAddr += pageremain;
            size -= pageremain;

            if(size > 256) pageremain = 256;
            else pageremain = size;
        }
    }
}

// д
void SPI_Flash_Write(u8 *pBuffer, u32 WriteAddr, u16 size) 
{
    u8  buffer[4096];
    u32 secpos;
    u16 secoff;
    u16 secremain;
    u16 i;

    secpos = WriteAddr / 4096;//ַ
    secoff = WriteAddr % 4096;//ڵƫ
    secremain = 4096 - secoff;//ʣռС

    if(size <= secremain) secremain = size;

    while(1) 
    {
        SPI_Flash_Read(buffer, secpos * 4096, 4096);                // ȡ
        for(i = 0; i < secremain; i++) 
        {
            if(buffer[secoff + i] != 0XFF) break;                   // 
        }
        if(i < secremain) 
        {                                         // ҪȲ
            SPI_Flash_Erase_Sector(secpos);
            for(i = 0; i < secremain; i++) 
            {                        // 
                buffer[i + secoff] = pBuffer[i];                    // Ҫд䵽
            }
            SPI_Flash_Write_NoCheck(buffer, secpos * 4096, 4096);   // д
        } else 
        {                                                    // Ҫ
            SPI_Flash_Write_NoCheck(pBuffer, WriteAddr, secremain); // ֱд
        }

        if(size == secremain) 
        { 
        	break; 
        }
        else 
        {
            secpos++;
            secoff = 0;

            pBuffer += secremain;
            WriteAddr += secremain;
            size -= secremain;

            if(size > 4096) 
            { 
            	secremain = 4096; 
            }
            else 
            { 
            	secremain = size; 
            }
        }
    }
}

// ȫƬ
void SPI_Flash_Erase_Chip(void) 
{
    SPI_FLASH_Write_Enable();            // ʹд
    SPI_Flash_Wait_Busy();               // ȴ
    GPIO_WriteBit(GPIOA, GPIO_Pin_2, 0); // ѡоƬ
    SPI1_ReadWriteByte(W25X_ChipErase);  // д
    GPIO_WriteBit(GPIOA, GPIO_Pin_2, 1); // ͷоƬ
    SPI_Flash_Wait_Busy();               // ȴ
}

// ʡģʽ
void SPI_Flash_PowerDown(void) 
{
    GPIO_WriteBit(GPIOA, GPIO_Pin_2, 0); // ѡоƬ
    SPI1_ReadWriteByte(W25X_PowerDown);  // д
    GPIO_WriteBit(GPIOA, GPIO_Pin_2, 1); // ͷоƬ
    Delay_Nop(3);                         // ȴ
}

// ʡģʽ
void SPI_Flash_WAKEUP(void) 
{
    GPIO_WriteBit(GPIOA, GPIO_Pin_2, 0);       // ѡоƬ
    SPI1_ReadWriteByte(W25X_ReleasePowerDown); // д
    GPIO_WriteBit(GPIOA, GPIO_Pin_2, 1);       // ͷоƬ
    Delay_Nop(3);                               // ȴ
}



//int main(void) 
//{
//    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);
//    SystemCoreClockUpdate();
//    Delay_Init();
//    USART_Printf_Init(115200);
//    printf("SystemClk:%d\r\n", SystemCoreClock);
//    printf("\r\n");
//
//    SPI1_Init(); // ʼSPI1
//
//    u16 Flash_Model = SPI_Flash_ReadID(); // ȡFlash ID
//    switch(Flash_Model) {
//        case W25Q80: printf("W25Q80 OK!\r\n"); break;
//        case W25Q16: printf("W25Q16 OK!\r\n"); break;
//        case W25Q32: printf("W25Q32 OK!\r\n"); break;
//        case W25Q64: printf("W25Q64 OK!\r\n"); break;
//        case W25Q128: printf("W25Q128 OK!\r\n"); break;
//        default: printf("Fail!\r\n"); break;
//    }
//
//    const u8 msg[] = "CH32F103 SPI FLASH W25Qxx";
//    const int size = sizeof(msg);
//    u8  buffer[size];
//
//    printf("Start Erase W25Qxx....\r\n");
//    SPI_Flash_Erase_Sector(0); // 
//    printf("W25Qxx Erase Finished!\r\n");
//    Delay_Ms(500);
//
//    printf("Start Read W25Qxx....\r\n");
//    SPI_Flash_Read(buffer, 0x0, size); // ȡ
//    printf("%s\r\n", buffer);
//    Delay_Ms(500);
//
//    printf("Start Write W25Qxx....\r\n");
//    SPI_Flash_Write((u8*)msg, 0, size); // д
//    printf("W25Qxx Write Finished!\r\n");
//    Delay_Ms(500);
//
//    printf("Start Read W25Qxx....\r\n");
//    SPI_Flash_Read(buffer, 0x0, size); // ٴζȡ
//    printf("%s\r\n", buffer);
//
//    while(1) {}
//}
