/*
 * sys.c
 *
 *  Created on: 2023517
 *      Author: Administrator
 */
#include "sys.h"

struct set_jgt set_inf;
struct bsp_jgt sys_inf;





/*********************************************************************
 * @fn      IWDG_Init
 *
 * @brief   Initializes IWDG.
 *
 * @param   IWDG_Prescaler: specifies the IWDG Prescaler value.
 *            IWDG_Prescaler_4: IWDG prescaler set to 4.
 *            IWDG_Prescaler_8: IWDG prescaler set to 8.
 *            IWDG_Prescaler_16: IWDG prescaler set to 16.
 *            IWDG_Prescaler_32: IWDG prescaler set to 32.
 *            IWDG_Prescaler_64: IWDG prescaler set to 64.
 *            IWDG_Prescaler_128: IWDG prescaler set to 128.
 *            IWDG_Prescaler_256: IWDG prescaler set to 256.
 *          Reload: specifies the IWDG Reload value.
 *            This parameter must be a number between 0 and 4095.
 *
 * @return  none
 */
void IWDG_Feed_Init(u16 prer, u16 rlr)
{//ʱ=4095/(40000/256)4095=ֵ40000=40K LSI256=Ƶϵ
    IWDG_WriteAccessCmd(IWDG_WriteAccess_Enable);
    IWDG_SetPrescaler(prer);
    IWDG_SetReload(rlr);
    IWDG_ReloadCounter();
    IWDG_Enable();
}
void weigou(void)
{
	if(sys_inf.iwdg_init_flg==1)
	{ //ι
		IWDG_ReloadCounter();
	}
}
/*  ϵͳʱ:SYSCLK, AHBʱ:HCLK, APB2ʱ:HCLK2, APB1ʱ:PCLK1
 * PCLK2 = HCLK = SYSCLK
 * PCLK1 = HCLK
 * ˵pllmulPLLıƵӣڵõʱǣRCC_PLLMul_x , x:[2,3,...16]
 * HSIΪʱԴPLLƵΪϵͳʱӣHSEϵʱʹõķ
 * HSIΪ¶ȵԭƯƣȶһ㲻HSIΪʱԴȲѵ
 * HSIҪΪPLLʱӵԴĻѡƵ߲ƵֱPLLоƬʹHSIʱ72MHzƵ
 * HSIΪPLLʱӣʾϵͳʱΪ 24MHz48MHz72MHz
 * HSI/2ΪPLLʱӣʾϵͳʱΪ 24MHz48MHz
 */
u8 HSI_SetSysClock(uint32_t pllmul)
{
    #if (PLL_Source == HSI)
        EXTEN->EXTEN_CTR |= EXTEN_PLL_HSI_PRE;  //HSIʱΪPLLʱ
    #endif
  __IO uint32_t HSIStartUpStatus = 0;
  // RCCʼɸλ״̬
  RCC_DeInit();
  //ʹHSI
  RCC_HSICmd(ENABLE);
  // ȴ HSI 
  HSIStartUpStatus = RCC->CTLR & RCC_HSIRDY;
  // ֻ HSIִ֮
  if (HSIStartUpStatus == RCC_HSIRDY)
  {
    // ǲFLASHõģFLASHĻע͵ҲûӰ
    // ʹFLASH Ԥȡ
//    FLASH_PrefetchBufferCmd(FLASH_PrefetchBuffer_Enable);
//    // SYSCLKʱıãͳһó2
//    // ó2ʱSYSCLK48MҲԹó01ʱ
//    // õSYSCLK˷ΧĻӲ󣬳
//    // 00 < SYSCLK <= 24M
//    // 124< SYSCLK <= 48M
//    // 248< SYSCLK <= 72M
//    FLASH_SetLatency(FLASH_Latency_2);
    // AHBԤƵΪ1ƵHCLK = SYSCLK
    RCC_HCLKConfig(RCC_SYSCLK_Div1);
    // APB2ԤƵΪ1ƵPCLK2 = HCLK
    RCC_PCLK2Config(RCC_HCLK_Div1);
    // APB1ԤƵΪ1ƵPCLK1 = HCLK/2
    RCC_PCLK1Config(RCC_HCLK_Div2);
    //-------øƵҪ----------//
    // PLLʱԴΪHSIPLLƵ
    // PLLCLK = 8MHz * pllmul
    // PLLʱԴΪHSI/2PLLƵ
    // PLLCLK = 4MHz * pllmul
    RCC_PLLConfig(RCC_PLLSource_HSI_Div2, pllmul);
    // PLL
    RCC_PLLCmd(ENABLE);
    // ȴ PLLȶ
    while (RCC_GetFlagStatus(RCC_FLAG_PLLRDY) == RESET)
    {

    }
    // PLLȶ֮󣬰PLLʱлΪϵͳʱSYSCLK
    RCC_SYSCLKConfig(RCC_SYSCLKSource_PLLCLK);
    // ȡʱл״̬λȷPLLCLKѡΪϵͳʱ
    while (RCC_GetSYSCLKSource() != 0x08)
    {

    }
    return 0;
  }
  else
  {
    // HSIʧܣôͻûӳĴ봦
    // HSEʧܻ߹ϵʱ򣬵ƬԶHSIΪϵͳʱӣHSIڲĸʱӣ8MHZ
    return 1;
  }
}

void Delay_Ms(u32 time_ms)
{
	sys_inf.systick_val=time_ms;
	while(sys_inf.systick_val)
	{
		asm("nop");
	}
}
void Delay_Nop(u32 time_nop)
{
    while(time_nop)
    {
        asm("nop");
        time_nop--;
    }
}

void gpio_init_lp(u8 stak)
{
    GPIO_InitTypeDef GPIO_InitStructure = {0};
    //EXTI_InitTypeDef EXTI_InitStructure = {0};
    //NVIC_InitTypeDef NVIC_InitStructure = {0};

    RCC_APB2PeriphClockCmd(RCC_APB2Periph_AFIO|RCC_APB2Periph_GPIOA, ENABLE);
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_AFIO|RCC_APB2Periph_GPIOB, ENABLE);
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_AFIO|RCC_APB2Periph_GPIOC, ENABLE);
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_AFIO|RCC_APB2Periph_GPIOD, ENABLE);
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_AFIO|RCC_APB2Periph_GPIOE, ENABLE);

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_All;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPD;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_10MHz;
    GPIO_Init(GPIOA, &GPIO_InitStructure);
    GPIO_Init(GPIOB, &GPIO_InitStructure);
    GPIO_Init(GPIOC, &GPIO_InitStructure);
    GPIO_Init(GPIOD, &GPIO_InitStructure);
    GPIO_Init(GPIOE, &GPIO_InitStructure);
    //GPIO_Init(GPIOF, &GPIO_InitStructure);
    //GPIO_Init(GPIOG, &GPIO_InitStructure);

	GPIO_InitStructure.GPIO_Pin= LED_PWR_R_Pin;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_10MHz;
	GPIO_Init(LED_PWR_R_GPIO_Port,&GPIO_InitStructure);
	LED_PWR_R_H;

	GPIO_InitStructure.GPIO_Pin= LED_PWR_G_Pin;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_10MHz;
	GPIO_Init(LED_PWR_G_GPIO_Port,&GPIO_InitStructure);
	LED_PWR_G_H;

	GPIO_InitStructure.GPIO_Pin= LED_PWR_B_Pin;
	GPIO_InitStructure.GPIO_Mode=GPIO_Mode_Out_PP;
	GPIO_InitStructure.GPIO_Speed=GPIO_Speed_10MHz;
	GPIO_Init(LED_PWR_B_GPIO_Port,&GPIO_InitStructure);
	LED_PWR_B_H;

	GPIO_InitStructure.GPIO_Pin= LED_NET_R_Pin;
	GPIO_InitStructure.GPIO_Mode=GPIO_Mode_Out_PP;
	GPIO_InitStructure.GPIO_Speed=GPIO_Speed_10MHz;
	GPIO_Init(LED_NET_R_GPIO_Port,&GPIO_InitStructure);
	LED_NET_R_H;

	GPIO_InitStructure.GPIO_Pin= LED_NET_G_Pin;
	GPIO_InitStructure.GPIO_Mode=GPIO_Mode_Out_PP;
	GPIO_InitStructure.GPIO_Speed=GPIO_Speed_10MHz;
	GPIO_Init(LED_NET_G_GPIO_Port,&GPIO_InitStructure);
	LED_NET_G_H;

	GPIO_InitStructure.GPIO_Pin= LED_NET_B_Pin;
	GPIO_InitStructure.GPIO_Mode=GPIO_Mode_Out_PP;
	GPIO_InitStructure.GPIO_Speed=GPIO_Speed_2MHz;
	GPIO_Init(LED_NET_B_GPIO_Port,&GPIO_InitStructure);
	LED_NET_B_H;
}
void beep(u8 stak)
{
	GPIO_InitTypeDef GPIO_InitStructure={0};
	if(stak==1)
	{
		GPIO_InitStructure.GPIO_Pin= BEEP_Pin;
		GPIO_InitStructure.GPIO_Mode=GPIO_Mode_Out_PP;
		GPIO_InitStructure.GPIO_Speed=GPIO_Speed_10MHz;
		GPIO_Init(BEEP_GPIO_Port,&GPIO_InitStructure);
		GPIO_WriteBit(BEEP_GPIO_Port,BEEP_Pin,Bit_SET);
	}else
	{
		GPIO_InitStructure.GPIO_Pin= BEEP_Pin;
		GPIO_InitStructure.GPIO_Mode=GPIO_Mode_Out_OD;
		GPIO_InitStructure.GPIO_Speed=GPIO_Speed_2MHz;
		GPIO_Init(BEEP_GPIO_Port,&GPIO_InitStructure);
		GPIO_WriteBit(BEEP_GPIO_Port,BEEP_Pin,Bit_RESET);
	}
}
void event_init(u8 stak)
{
	GPIO_InitTypeDef GPIO_InitStructure={0};
	EXTI_InitTypeDef EXTI_InitStructure={0};
	NVIC_InitTypeDef NVIC_InitStructure={0};
	if(stak==1)
	{
//		GPIO_InitStructure.GPIO_Pin= USB_IN_Pin;
//		GPIO_InitStructure.GPIO_Mode=GPIO_Mode_IPU;
//		GPIO_Init(USB_IN_GPIO_Port,&GPIO_InitStructure);
//		GPIO_EXTILineConfig(GPIO_PortSourceGPIOC,GPIO_PinSource9);
//		EXTI_InitStructure.EXTI_Line= EXTI_Line9;
//		EXTI_InitStructure.EXTI_Mode=EXTI_Mode_Interrupt;
//		EXTI_InitStructure.EXTI_Trigger=EXTI_Trigger_Falling;
//		EXTI_InitStructure.EXTI_LineCmd=ENABLE;
//		EXTI_Init(&EXTI_InitStructure);
//		NVIC_InitStructure.NVIC_IRQChannel=EXTI9_5_IRQn;
//		NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority=1;
//		NVIC_InitStructure.NVIC_IRQChannelSubPriority=0;
//		NVIC_InitStructure.NVIC_IRQChannelCmd=ENABLE;
//		NVIC_Init(&NVIC_InitStructure);
//
//		GPIO_InitStructure.GPIO_Pin= CD_FLG_Pin;
//		GPIO_InitStructure.GPIO_Mode=GPIO_Mode_IPU;
//		GPIO_Init(CD_FLG_GPIO_Port,&GPIO_InitStructure);
//		GPIO_EXTILineConfig(GPIO_PortSourceGPIOC,GPIO_PinSource8);
//		EXTI_InitStructure.EXTI_Line= EXTI_Line8;
//		EXTI_InitStructure.EXTI_Mode=EXTI_Mode_Interrupt;
//		EXTI_InitStructure.EXTI_Trigger=EXTI_Trigger_Falling;
//		EXTI_InitStructure.EXTI_LineCmd=ENABLE;
//		EXTI_Init(&EXTI_InitStructure);
//		NVIC_InitStructure.NVIC_IRQChannel=EXTI9_5_IRQn;
//		NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority=1;
//		NVIC_InitStructure.NVIC_IRQChannelSubPriority=0;
//		NVIC_InitStructure.NVIC_IRQChannelCmd=ENABLE;
//		NVIC_Init(&NVIC_InitStructure);
//
//		GPIO_InitStructure.GPIO_Pin= CD_OK_Pin;
//		GPIO_InitStructure.GPIO_Mode=GPIO_Mode_IPU;
//		GPIO_Init(CD_OK_GPIO_Port,&GPIO_InitStructure);
//		GPIO_EXTILineConfig(GPIO_PortSourceGPIOC,GPIO_PinSource7);
//		EXTI_InitStructure.EXTI_Line= EXTI_Line7;
//		EXTI_InitStructure.EXTI_Mode=EXTI_Mode_Interrupt;
//		EXTI_InitStructure.EXTI_Trigger=EXTI_Trigger_Falling;
//		EXTI_InitStructure.EXTI_LineCmd=ENABLE;
//		EXTI_Init(&EXTI_InitStructure);
//		NVIC_InitStructure.NVIC_IRQChannel=EXTI9_5_IRQn;
//		NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority=1;
//		NVIC_InitStructure.NVIC_IRQChannelSubPriority=0;
//		NVIC_InitStructure.NVIC_IRQChannelCmd=ENABLE;
//		NVIC_Init(&NVIC_InitStructure);


		
		GPIO_InitStructure.GPIO_Pin= KEY1_Pin;
		GPIO_InitStructure.GPIO_Speed=GPIO_Speed_2MHz;
		GPIO_InitStructure.GPIO_Mode=GPIO_Mode_IPU;
		GPIO_Init(KEY1_GPIO_Port,&GPIO_InitStructure);		
		GPIO_EXTILineConfig(GPIO_PortSourceGPIOC,GPIO_PinSource6);
		EXTI_InitStructure.EXTI_Line= EXTI_Line6;
		EXTI_InitStructure.EXTI_Mode=EXTI_Mode_Interrupt;
		EXTI_InitStructure.EXTI_Trigger=EXTI_Trigger_Falling;
		EXTI_InitStructure.EXTI_LineCmd=ENABLE;
		EXTI_Init(&EXTI_InitStructure);		
		NVIC_InitStructure.NVIC_IRQChannel=EXTI9_5_IRQn;
		NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority=1;
		NVIC_InitStructure.NVIC_IRQChannelSubPriority=0;
		NVIC_InitStructure.NVIC_IRQChannelCmd=ENABLE;
		NVIC_Init(&NVIC_InitStructure);

		GPIO_InitStructure.GPIO_Pin= KEY2_Pin;
		GPIO_InitStructure.GPIO_Mode=GPIO_Mode_IPU;
		GPIO_Init(KEY2_GPIO_Port,&GPIO_InitStructure);
		GPIO_EXTILineConfig(GPIO_PortSourceGPIOB,GPIO_PinSource15);
		EXTI_InitStructure.EXTI_Line= EXTI_Line15;
		EXTI_InitStructure.EXTI_Mode=EXTI_Mode_Interrupt;
		EXTI_InitStructure.EXTI_Trigger=EXTI_Trigger_Falling;
		EXTI_InitStructure.EXTI_LineCmd=ENABLE;
		EXTI_Init(&EXTI_InitStructure);
		NVIC_InitStructure.NVIC_IRQChannel=EXTI15_10_IRQn;
		NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority=1;
		NVIC_InitStructure.NVIC_IRQChannelSubPriority=0;
		NVIC_InitStructure.NVIC_IRQChannelCmd=ENABLE;
		NVIC_Init(&NVIC_InitStructure);

		GPIO_InitStructure.GPIO_Pin= KEY3_Pin;
		GPIO_InitStructure.GPIO_Mode=GPIO_Mode_IPU;
		GPIO_Init(KEY3_GPIO_Port,&GPIO_InitStructure);
		GPIO_EXTILineConfig(GPIO_PortSourceGPIOB,GPIO_PinSource14);
		EXTI_InitStructure.EXTI_Line= EXTI_Line14;
		EXTI_InitStructure.EXTI_Mode=EXTI_Mode_Interrupt;
		EXTI_InitStructure.EXTI_Trigger=EXTI_Trigger_Falling;
		EXTI_InitStructure.EXTI_LineCmd=ENABLE;
		EXTI_Init(&EXTI_InitStructure);
		NVIC_InitStructure.NVIC_IRQChannel=EXTI15_10_IRQn;
		NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority=1;
		NVIC_InitStructure.NVIC_IRQChannelSubPriority=0;
		NVIC_InitStructure.NVIC_IRQChannelCmd=ENABLE;
		NVIC_Init(&NVIC_InitStructure);

		GPIO_InitStructure.GPIO_Pin= KEY4_Pin;
		GPIO_InitStructure.GPIO_Mode=GPIO_Mode_IPU;
		GPIO_Init(KEY3_GPIO_Port,&GPIO_InitStructure);
		GPIO_EXTILineConfig(GPIO_PortSourceGPIOB,GPIO_PinSource13);
		EXTI_InitStructure.EXTI_Line= EXTI_Line13;
		EXTI_InitStructure.EXTI_Mode=EXTI_Mode_Interrupt;
		EXTI_InitStructure.EXTI_Trigger=EXTI_Trigger_Falling;
		EXTI_InitStructure.EXTI_LineCmd=ENABLE;
		EXTI_Init(&EXTI_InitStructure);
		NVIC_InitStructure.NVIC_IRQChannel=EXTI15_10_IRQn;
		NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority=1;
		NVIC_InitStructure.NVIC_IRQChannelSubPriority=0;
		NVIC_InitStructure.NVIC_IRQChannelCmd=ENABLE;
		NVIC_Init(&NVIC_InitStructure);

		GPIO_InitStructure.GPIO_Pin= KEY5_Pin;
		GPIO_InitStructure.GPIO_Mode=GPIO_Mode_IPU;
		GPIO_Init(KEY5_GPIO_Port,&GPIO_InitStructure);
		GPIO_EXTILineConfig(GPIO_PortSourceGPIOB,GPIO_PinSource12);
		EXTI_InitStructure.EXTI_Line= EXTI_Line12;
		EXTI_InitStructure.EXTI_Mode=EXTI_Mode_Interrupt;
		EXTI_InitStructure.EXTI_Trigger=EXTI_Trigger_Falling;
		EXTI_InitStructure.EXTI_LineCmd=ENABLE;
		EXTI_Init(&EXTI_InitStructure);
		NVIC_InitStructure.NVIC_IRQChannel=EXTI15_10_IRQn;
		NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority=1;
		NVIC_InitStructure.NVIC_IRQChannelSubPriority=0;
		NVIC_InitStructure.NVIC_IRQChannelCmd=ENABLE;
		NVIC_Init(&NVIC_InitStructure);
	}else
	{
		GPIO_InitStructure.GPIO_Pin= USB_IN_Pin;
		GPIO_InitStructure.GPIO_Mode=GPIO_Mode_Out_OD;
		GPIO_Init(USB_IN_GPIO_Port,&GPIO_InitStructure);
		GPIO_WriteBit(USB_IN_GPIO_Port,USB_IN_Pin,Bit_RESET);

		GPIO_InitStructure.GPIO_Pin= CD_FLG_Pin;
		GPIO_InitStructure.GPIO_Mode=GPIO_Mode_Out_OD;
		GPIO_Init(CD_FLG_GPIO_Port,&GPIO_InitStructure);
		GPIO_WriteBit(CD_FLG_GPIO_Port,CD_FLG_Pin,Bit_RESET);

		GPIO_InitStructure.GPIO_Pin= CD_OK_Pin;
		GPIO_InitStructure.GPIO_Mode=GPIO_Mode_Out_OD;
		GPIO_Init(CD_OK_GPIO_Port,&GPIO_InitStructure);
		GPIO_WriteBit(CD_OK_GPIO_Port,CD_OK_Pin,Bit_RESET);


		GPIO_InitStructure.GPIO_Pin= KEY1_Pin;
		GPIO_InitStructure.GPIO_Mode=GPIO_Mode_Out_OD;
		GPIO_Init(KEY1_GPIO_Port,&GPIO_InitStructure);
		GPIO_WriteBit(KEY1_GPIO_Port,KEY1_Pin,Bit_RESET);

		GPIO_InitStructure.GPIO_Pin= KEY2_Pin;
		GPIO_InitStructure.GPIO_Mode=GPIO_Mode_Out_OD;
		GPIO_Init(KEY2_GPIO_Port,&GPIO_InitStructure);
		GPIO_WriteBit(KEY2_GPIO_Port,KEY2_Pin,Bit_RESET);

		GPIO_InitStructure.GPIO_Pin= KEY3_Pin;
		GPIO_InitStructure.GPIO_Mode=GPIO_Mode_Out_OD;
		GPIO_Init(KEY3_GPIO_Port,&GPIO_InitStructure);
		GPIO_WriteBit(KEY3_GPIO_Port,KEY3_Pin,Bit_RESET);

		GPIO_InitStructure.GPIO_Pin= KEY4_Pin;
		GPIO_InitStructure.GPIO_Mode=GPIO_Mode_Out_OD;
		GPIO_Init(KEY4_GPIO_Port,&GPIO_InitStructure);
		GPIO_WriteBit(KEY4_GPIO_Port,KEY4_Pin,Bit_RESET);

		GPIO_InitStructure.GPIO_Pin= KEY5_Pin;
		GPIO_InitStructure.GPIO_Mode=GPIO_Mode_Out_OD;
		GPIO_Init(KEY5_GPIO_Port,&GPIO_InitStructure);
		GPIO_WriteBit(KEY5_GPIO_Port,KEY5_Pin,Bit_RESET);
	}
}
void smgv_sw(u8 stak)
{
	GPIO_InitTypeDef GPIO_InitStructure={0};
	if(stak==1)
	{
		GPIO_InitStructure.GPIO_Pin= SMGV_SW_Pin;
		GPIO_InitStructure.GPIO_Mode=GPIO_Mode_Out_PP;
		GPIO_InitStructure.GPIO_Speed=GPIO_Speed_10MHz;
		GPIO_Init(SMGV_SW_GPIO_Port,&GPIO_InitStructure);
		GPIO_WriteBit(SMGV_SW_GPIO_Port,SMGV_SW_Pin,Bit_SET);
	}else
	{
		GPIO_InitStructure.GPIO_Pin= SMGV_SW_Pin;
		GPIO_InitStructure.GPIO_Mode=GPIO_Mode_Out_OD;
		GPIO_InitStructure.GPIO_Speed=GPIO_Speed_10MHz;
		GPIO_Init(SMGV_SW_GPIO_Port,&GPIO_InitStructure);
		GPIO_WriteBit(SMGV_SW_GPIO_Port,SMGV_SW_Pin,Bit_RESET);
	}
}
void mt1_out(u8 stak)
{
	GPIO_InitTypeDef GPIO_InitStructure=
	{
	0
	};
	if(stak==1)
	{
		GPIO_InitStructure.GPIO_Pin= MT1_Pin;
		GPIO_InitStructure.GPIO_Mode=GPIO_Mode_Out_PP;
		GPIO_InitStructure.GPIO_Speed=GPIO_Speed_10MHz;
		GPIO_Init(MT1_GPIO_Port,&GPIO_InitStructure);
		GPIO_WriteBit(MT1_GPIO_Port,MT1_Pin,Bit_SET);
	}else
	{
		GPIO_InitStructure.GPIO_Pin= MT1_Pin;
		GPIO_InitStructure.GPIO_Mode=GPIO_Mode_Out_OD;
		GPIO_InitStructure.GPIO_Speed=GPIO_Speed_10MHz;
		GPIO_Init(MT1_GPIO_Port,&GPIO_InitStructure);
		GPIO_WriteBit(MT1_GPIO_Port,MT1_Pin,Bit_RESET);
	}
}
void mt2_out(u8 stak)
{
	GPIO_InitTypeDef GPIO_InitStructure=
	{
	0
	};
	if(stak==1)
	{
		GPIO_InitStructure.GPIO_Pin= MT2_Pin;
		GPIO_InitStructure.GPIO_Mode=GPIO_Mode_Out_PP;
		GPIO_InitStructure.GPIO_Speed=GPIO_Speed_10MHz;
		GPIO_Init(MT2_GPIO_Port,&GPIO_InitStructure);
		GPIO_WriteBit(MT2_GPIO_Port,MT2_Pin,Bit_SET);
	}else
	{
		GPIO_InitStructure.GPIO_Pin= MT2_Pin;
		GPIO_InitStructure.GPIO_Mode=GPIO_Mode_Out_OD;
		GPIO_InitStructure.GPIO_Speed=GPIO_Speed_10MHz;
		GPIO_Init(MT2_GPIO_Port,&GPIO_InitStructure);
		GPIO_WriteBit(MT2_GPIO_Port,MT2_Pin,Bit_RESET);
	}
}

void adc_init(u8 stak)
{
    ADC_InitTypeDef  ADC_InitStructure = {0};
	GPIO_InitTypeDef GPIO_InitStructure=
	{
	0
	};

    if(stak==1)
    {
        RCC_APB2PeriphClockCmd(RCC_APB2Periph_ADC1, ENABLE);

		GPIO_InitStructure.GPIO_Pin= ADCV_SW_Pin;
		GPIO_InitStructure.GPIO_Mode=GPIO_Mode_Out_PP;
		GPIO_InitStructure.GPIO_Speed=GPIO_Speed_10MHz;
		GPIO_Init(ADCV_SW_GPIO_Port,&GPIO_InitStructure);
		GPIO_WriteBit(ADCV_SW_GPIO_Port,ADCV_SW_Pin,Bit_SET);

		GPIO_InitStructure.GPIO_Pin=BATV_CL_Pin;
		GPIO_InitStructure.GPIO_Mode=GPIO_Mode_AIN;
		GPIO_Init(BATV_CL_GPIO_Port,&GPIO_InitStructure);

		GPIO_InitStructure.GPIO_Pin= MTI1_CL_Pin;
		GPIO_InitStructure.GPIO_Mode=GPIO_Mode_AIN;
		GPIO_Init(MTI1_CL_GPIO_Port,&GPIO_InitStructure);

		GPIO_InitStructure.GPIO_Pin= MTI2_CL_Pin;
		GPIO_InitStructure.GPIO_Mode=GPIO_Mode_AIN;
		GPIO_Init(MTI2_CL_GPIO_Port,&GPIO_InitStructure);

        ADC_DeInit(ADC1);
        RCC_ADCCLKConfig(RCC_PCLK2_Div2); //ADCʱӷƵΪ2Ƶ
        ADC_InitStructure.ADC_Mode = ADC_Mode_Independent;//ADCΪģʽ
        ADC_InitStructure.ADC_ScanConvMode = DISABLE;//ڵͨģʽִת
        ADC_InitStructure.ADC_ContinuousConvMode = DISABLE;//ڵģʽִת
        ADC_InitStructure.ADC_ExternalTrigConv = ADC_ExternalTrigConv_None;//תⲿ
        ADC_InitStructure.ADC_DataAlign = ADC_DataAlign_Right;//ADCҶ
        ADC_InitStructure.ADC_NbrOfChannel = 1;//˳йתADCͨĿ
        ADC_Init(ADC1, &ADC_InitStructure);
        ADC_Cmd(ADC1, ENABLE);
        ADC_ResetCalibration(ADC1);//ADCУ׼Ĵ
        while(ADC_GetResetCalibrationStatus(ADC1));//ȴλУ׼
        ADC_StartCalibration(ADC1);//ʼADCУ׼
        while(ADC_GetCalibrationStatus(ADC1));//ȴ
        ////sys_inf.adc_adj_val = ADC_Get_CalibrationValue(ADC1);
        ////ADC_TempSensorVrefintCmd(ENABLE);
    }else
    {
        RCC_APB2PeriphClockCmd(RCC_APB2Periph_ADC1, DISABLE);

		GPIO_InitStructure.GPIO_Pin= ADCV_SW_Pin;
		GPIO_InitStructure.GPIO_Mode=GPIO_Mode_Out_OD;
		GPIO_InitStructure.GPIO_Speed=GPIO_Speed_10MHz;
		GPIO_Init(ADCV_SW_GPIO_Port,&GPIO_InitStructure);
		GPIO_WriteBit(ADCV_SW_GPIO_Port,ADCV_SW_Pin,Bit_RESET);

		GPIO_InitStructure.GPIO_Pin=BATV_CL_Pin;
		GPIO_InitStructure.GPIO_Mode=GPIO_Mode_Out_OD;
		GPIO_Init(BATV_CL_GPIO_Port,&GPIO_InitStructure);
		GPIO_WriteBit(BATV_CL_GPIO_Port,BATV_CL_Pin,Bit_RESET);

		GPIO_InitStructure.GPIO_Pin= MTI1_CL_Pin;
		GPIO_InitStructure.GPIO_Mode=GPIO_Mode_Out_OD;
		GPIO_Init(MTI1_CL_GPIO_Port,&GPIO_InitStructure);
		GPIO_WriteBit(MTI1_CL_GPIO_Port,MTI1_CL_Pin,Bit_RESET);

		GPIO_InitStructure.GPIO_Pin= MTI2_CL_Pin;
		GPIO_InitStructure.GPIO_Mode=GPIO_Mode_Out_OD;
		GPIO_Init(MTI2_CL_GPIO_Port,&GPIO_InitStructure);
		GPIO_WriteBit(MTI2_CL_GPIO_Port,MTI2_CL_Pin,Bit_RESET);

		ADC_DeInit(ADC1);
        ADC_Cmd(ADC1, DISABLE);
    }
}
u16 Get_ADC_Val(u8 ch)
{
    u16 val;
    ADC_RegularChannelConfig(ADC1, ch, 1, ADC_SampleTime_239Cycles5);
    ADC_SoftwareStartConvCmd(ADC1, ENABLE);
    while(!ADC_GetFlagStatus(ADC1, ADC_FLAG_EOC));
    val = ADC_GetConversionValue(ADC1);
    return val;
}
u16 Get_ADC_Average(u8 ch, u8 times)
{
    u32 temp_val = 0;
    u8  t;
    u16 val;
    for(t = 0; t < times; t++)
    {
        temp_val += Get_ADC_Val(ch);
        Delay_Ms(5);
    }
    val = temp_val / times;
    return val;
}
u16 Get_ConversionVal_3_3V(s16 val)
{
    int32_t y;
    y = 6 * (val + sys_inf.adc_adj_val) / 1000 - 12;
    if(val == 0 || val == 4095)
        return val;
    else
    {
        if((val + sys_inf.adc_adj_val - y) < 0)
            return 0;
        if((sys_inf.adc_adj_val + val - y) > 4095)
            return 4095;
        return (val + sys_inf.adc_adj_val);
    }
}
u16 Get_ConversionVal_5V(s16 val)
{
    int32_t y;
    y = 4 * (val + sys_inf.adc_adj_val) / 1000 - 8;
    if(val == 0 || val == 4095)
        return val;
    else
    {
        if((val + sys_inf.adc_adj_val - y) < 0)
            return 0;
        if((sys_inf.adc_adj_val + val - y) > 4095)
            return 4095;
        return (val + sys_inf.adc_adj_val);
    }
}
void wiblv_sw(u8 stak)
{
	GPIO_InitTypeDef GPIO_InitStructure={0};
	if(stak==1)
	{
		GPIO_InitStructure.GPIO_Pin=WIFI_SW_Pin;
		GPIO_InitStructure.GPIO_Mode=GPIO_Mode_Out_PP;
		GPIO_InitStructure.GPIO_Speed=GPIO_Speed_10MHz;
		GPIO_Init(WIFI_RST_GPIO_Port,&GPIO_InitStructure);
		GPIO_WriteBit(WIFI_RST_GPIO_Port,WIFI_RST_Pin,Bit_SET);
	}else
	{
		GPIO_InitStructure.GPIO_Pin= WIFI_RST_Pin;
		GPIO_InitStructure.GPIO_Mode=GPIO_Mode_Out_OD;
		GPIO_InitStructure.GPIO_Speed=GPIO_Speed_10MHz;
		GPIO_Init(WIFI_RST_GPIO_Port,&GPIO_InitStructure);
		GPIO_WriteBit(WIFI_RST_GPIO_Port,WIFI_RST_Pin,Bit_RESET);
	}
}
void wibl_en(u8 stak)
{
	GPIO_InitTypeDef GPIO_InitStructure={0};
	if(stak==1)
	{
		GPIO_InitStructure.GPIO_Pin= WIFI_EN_Pin;
		GPIO_InitStructure.GPIO_Mode=GPIO_Mode_Out_PP;
		GPIO_InitStructure.GPIO_Speed=GPIO_Speed_10MHz;
		GPIO_Init(WIFI_EN_GPIO_Port,&GPIO_InitStructure);
		GPIO_WriteBit(WIFI_EN_GPIO_Port,WIFI_EN_Pin,Bit_SET);
	}else
	{
		GPIO_InitStructure.GPIO_Pin= WIFI_EN_Pin;
		GPIO_InitStructure.GPIO_Mode=GPIO_Mode_Out_OD;
		GPIO_InitStructure.GPIO_Speed=GPIO_Speed_10MHz;
		GPIO_Init(WIFI_RST_GPIO_Port,&GPIO_InitStructure);
		GPIO_WriteBit(WIFI_EN_GPIO_Port,WIFI_EN_Pin,Bit_RESET);
	}
}
void wibl_rst(u8 stak)
{
	GPIO_InitTypeDef GPIO_InitStructure=
	{
	0
	};
	if(stak==1)
	{
		GPIO_InitStructure.GPIO_Pin= WIFI_RST_Pin;
		GPIO_InitStructure.GPIO_Mode=GPIO_Mode_Out_PP;
		GPIO_InitStructure.GPIO_Speed=GPIO_Speed_10MHz;
		GPIO_Init(WIFI_RST_GPIO_Port,&GPIO_InitStructure);
		GPIO_WriteBit(WIFI_RST_GPIO_Port,WIFI_RST_Pin,Bit_SET);
	}else
	{
		GPIO_InitStructure.GPIO_Pin= WIFI_RST_Pin;
		GPIO_InitStructure.GPIO_Mode=GPIO_Mode_Out_OD;
		GPIO_InitStructure.GPIO_Speed=GPIO_Speed_10MHz;
		GPIO_Init(WIFI_RST_GPIO_Port,&GPIO_InitStructure);
		GPIO_WriteBit(WIFI_RST_GPIO_Port,WIFI_RST_Pin,Bit_RESET);
	}
}
void wibl_init(u8 stak,u32 btlv)
{
    GPIO_InitTypeDef  GPIO_InitStructure = {0};
    USART_InitTypeDef USART_InitStructure = {0};
    NVIC_InitTypeDef  NVIC_InitStructure = {0};
	if(stak==1)
	{
		RCC_APB2PeriphClockCmd(RCC_APB2Periph_USART1,ENABLE);

		/* USART1 TX-->A.9   RX-->A.10 */
		GPIO_InitStructure.GPIO_Pin=WIFI_TX_Pin;
		GPIO_InitStructure.GPIO_Speed=GPIO_Speed_50MHz;
		GPIO_InitStructure.GPIO_Mode=GPIO_Mode_IN_FLOATING;
		GPIO_Init(WIFI_TX_GPIO_Port,&GPIO_InitStructure);

		GPIO_InitStructure.GPIO_Pin=WIFI_RX_Pin;
		GPIO_InitStructure.GPIO_Speed=GPIO_Speed_50MHz;
		GPIO_InitStructure.GPIO_Mode=GPIO_Mode_AF_PP;
		GPIO_Init(WIFI_RX_GPIO_Port,&GPIO_InitStructure);

		USART_InitStructure.USART_BaudRate=btlv;
		USART_InitStructure.USART_WordLength= USART_WordLength_8b;
		USART_InitStructure.USART_StopBits= USART_StopBits_1;
		USART_InitStructure.USART_Parity= USART_Parity_No;
		USART_InitStructure.USART_HardwareFlowControl=
		        USART_HardwareFlowControl_None;
		USART_InitStructure.USART_Mode= USART_Mode_Tx|USART_Mode_Rx;
		USART_Init(USART1,&USART_InitStructure);

		NVIC_InitStructure.NVIC_IRQChannel=USART1_IRQn;
		NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority=0;
		NVIC_InitStructure.NVIC_IRQChannelSubPriority=0;
		NVIC_InitStructure.NVIC_IRQChannelCmd=ENABLE;
		NVIC_Init(&NVIC_InitStructure);

		USART_Cmd(USART1,ENABLE);
		USART_ITConfig(USART1,USART_IT_RXNE,ENABLE);
	}else
	{
		RCC_APB2PeriphClockCmd(RCC_APB2Periph_USART1,DISABLE);

		/* USART1 TX-->A.9   RX-->A.10 */
		GPIO_InitStructure.GPIO_Pin=WIFI_TX_Pin;
		GPIO_InitStructure.GPIO_Speed=GPIO_Speed_2MHz;
		GPIO_InitStructure.GPIO_Mode=GPIO_Mode_Out_OD;
		GPIO_Init(WIFI_TX_GPIO_Port,&GPIO_InitStructure);
		GPIO_WriteBit(WIFI_TX_GPIO_Port,WIFI_TX_Pin,Bit_RESET);

		GPIO_InitStructure.GPIO_Pin=WIFI_RX_Pin;
		GPIO_InitStructure.GPIO_Speed=GPIO_Speed_2MHz;
		GPIO_InitStructure.GPIO_Mode=GPIO_Mode_Out_OD;
		GPIO_Init(WIFI_RX_GPIO_Port,&GPIO_InitStructure);
		GPIO_WriteBit(WIFI_RX_GPIO_Port,WIFI_RX_Pin,Bit_RESET);

		USART_Cmd(USART1,DISABLE);
		USART_ITConfig(USART1,USART_IT_RXNE,DISABLE);
	}
}
void wibl_kill(char type)
{
    if(type=='t')
    {
		memset(sys_inf.wibl_tx_buf,0,def_wibl_tx_buf_max-1);
		sys_inf.wibl_tx_wei=0;
    }
    if(type=='r')
    {
		memset(sys_inf.wibl_rx_buf,0,def_wibl_rx_buf_max-1);
		sys_inf.wibl_rx_wei=0;
    }
}
void wibl_printf(char *fmt,...)
{
    u16 i;
	va_list arg_ptr;
	char buffer[def_wibl_tx_buf_max];
	//__disable_irq();
	va_start(arg_ptr,fmt);
	vsnprintf(buffer,def_wibl_tx_buf_max-5,fmt,arg_ptr);
    i=strlen(buffer);
	wibl_send_hex((u8*)&buffer[0],i);
	va_end(arg_ptr);
	//__enable_irq();
}
void wibl_send_hex(u8 *data,u16 data_len)
{
    u16 i=0;

    do
    {
        while(USART_GetFlagStatus(USART1, USART_FLAG_TC) == RESET);
		USART_SendData(USART1,data[i]);
        i++;
	}while(i<data_len);

}
u8 wibl_wait_hui(u32 hui_timeout_ms,u8 hui_cs,char *hui_str0,char *hui_str1,char *hui_str2,char *fmt,...)
{ //tx_str=ȥݡhui_timeout_ms=Ժȴʱ
	while(hui_cs)
	{
		u16 i;
		va_list arg_ptr;
		char buffer[def_wibl_tx_buf_max];

		u32 timeout_ms=hui_timeout_ms;

		hui_cs--;
		wibl_kill('r');wibl_kill('t');

		rt_thread_mdelay(500); //Լʱ

		va_start(arg_ptr,fmt);
		vsnprintf(buffer,def_wibl_tx_buf_max-5,fmt,arg_ptr);
		i=strlen(buffer);
		wibl_send_hex((u8*)&buffer[0],i);
		va_end(arg_ptr);

		timeout_ms=hui_timeout_ms;
		while(timeout_ms)
		{ //ȴ
			rt_thread_mdelay(100);weigou();
			if(timeout_ms<=100)
			{
				timeout_ms=0;
			} else
			{
				timeout_ms-=100;
			}

			if(strstr((const char*)sys_inf.wibl_rx_buf,hui_str0)!=NULL)
			{ //0ȷ
				break;
			}
			if(strstr((const char*)sys_inf.wibl_rx_buf,hui_str1)!=NULL)
			{ //1ȷ
				break;
			}
			if(strstr((const char*)sys_inf.wibl_rx_buf,hui_str2)!=NULL)
			{ //2ȷ
				break;
			}
		}
		if(timeout_ms!=0)
		{ //ȷ
			break;
		}
	}
	if(hui_cs>0)
	{
		return 0;
	}else
	{
		return 1;
	}
}
u16 byte_ss(char *pk,char str,u16 wei)
{
	u16 i=0;
	for(i=0;i<wei;i++)
	{
		if(pk[i]==str)
		{
			return i;
		}
	}
	return wei;
}
char* mystrstr(char* dest,char* src,u16 data_len)
{
	char* tdest=dest;
	char* tsrc=src;
	int i=0; //tdest Ԫ±λã±0ʼңͨã±꿪ʼң
	int j=0; //tsrc ӴԪ±λ
	while (i <= (data_len - 1) && j <= strlen(tsrc)-1)
	{
		if (tdest[i] == tsrc[j]) //ַȣƥһַ
		{
			i++;
			j++;
		}
		else //ƥзһַӴеĲȣϻ˵ һҪƥλ
		{
			i = i - j + 1;
			j = 0;
		}
	}
	//ѭ˺jֵstrlen(tsrc) ӴеַѾжƥ䵽
	if(j==strlen(tsrc))
	{
		return tdest+i-strlen(tsrc);
	}

	return NULL;
}
u16 str_copy_run_end(char *mubiao,char *yuan,char run_char,char end_char,u16 len)
{
	sys_inf.json_data_run=byte_ss((char*)yuan,run_char,len);
	sys_inf.json_data_end=byte_ss((char*)yuan,end_char,len);
	if((sys_inf.json_data_run<sys_inf.json_data_end)&&((sys_inf.json_data_run!=0xffff)&&(sys_inf.json_data_end!=0xffff)))
	{
		memcpy(mubiao,yuan+sys_inf.json_data_run,(sys_inf.json_data_end-sys_inf.json_data_run)+1);
		return (sys_inf.json_data_end-sys_inf.json_data_run)+1;
	}
	return 0;
}
char *json_mak(char *data_type) //json
{
	char *out=0;
	cJSON *pJsonRoot=NULL;
	pJsonRoot=cJSON_CreateObject(); //
	if(NULL==pJsonRoot)
	{ //ʧ
		return "pJsonRoot_err";
	}
	if(1)
	{ //
		cJSON_AddStringToObject(pJsonRoot,"dev_ty",sys_inf.dev_ty_str); //豸
		cJSON_AddStringToObject(pJsonRoot,"dev_id",set_inf.dev_id_str); //豸ID
		cJSON_AddStringToObject(pJsonRoot,"pak_ty",data_type); //
		cJSON_AddNumberToObject(pJsonRoot,"pcb_ver",sys_inf.pcb_vr); //PCB·汾
		cJSON_AddNumberToObject(pJsonRoot,"bot_ver",set_inf.bl_vr); //ԶBL汾
		cJSON_AddNumberToObject(pJsonRoot,"app_ver",sys_inf.ap_vr); //APP汾
		cJSON_AddNumberToObject(pJsonRoot,"run_s",sys_inf.run_s); //˶
		cJSON_AddNumberToObject(pJsonRoot,"net_ty",1); //ͨ
		cJSON_AddNumberToObject(pJsonRoot,"link_ty",1); //

//		cJSON_AddNumberToObject(pJsonRoot,"rssi",sys_inf.rf433_rssi); //źǿ
//		cJSON_AddNumberToObject(pJsonRoot,"snr",sys_inf.rf433_snr); //
//
		cJSON_AddStringToObject(pJsonRoot,"mk_id",sys_inf.wibl_imei); //IMEI
		cJSON_AddStringToObject(pJsonRoot,"ka_id",sys_inf.wibl_imsi); //IMSI
		cJSON_AddNumberToObject(pJsonRoot,"inv",sys_inf.jg_s_cj); //̫ܻѹ
//		cJSON_AddNumberToObject(pJsonRoot,"bat_v",sys_inf.batv_val); //صѹ
//		cJSON_AddNumberToObject(pJsonRoot,"gn_wd",sys_inf.sys_dw_wd); //GNSSγ
//		cJSON_AddNumberToObject(pJsonRoot,"gn_jd",sys_inf.sys_dw_jd); //GNSS
//		cJSON_AddNumberToObject(pJsonRoot,"gn_hb",sys_inf.sys_dw_hb); //GNSS

		//cJSON_AddNumberToObject(pJsonRoot,"dqf_stak",sys_inf.dqf_stak); //ŵǰ״̬
		//cJSON_AddNumberToObject(pJsonRoot,"dqf_kai_s",sys_inf.dqf_kai_s); //
		//cJSON_AddNumberToObject(pJsonRoot,"llj_clk",sys_inf.llj_clk_val); //

		cJSON_AddNumberToObject(pJsonRoot,"cj_s",0); //ɼ
		cJSON_AddNumberToObject(pJsonRoot,"up_s",set_inf.jg_s_up); //ϴ
		cJSON_AddNumberToObject(pJsonRoot,"xt_s",0); //
		cJSON_AddNumberToObject(pJsonRoot,"mem_sx",0); //ʣڴ
		cJSON_AddNumberToObject(pJsonRoot,"err_cd",sys_inf.err); //

	}
	if(1)
	{
		out=cJSON_PrintUnformatted(pJsonRoot); //pJsonRootṹתַ
		if(NULL==out)
		{ //ʧ
			cJSON_Delete(pJsonRoot);
			return "cJSON_Print_err";
		}else
		{
			cJSON_Delete(pJsonRoot);

			memset(sys_inf.json_out_buf,0,def_wibl_tx_buf_max);
			memcpy(sys_inf.json_out_buf,out,(strlen(out)));
			free(out);
		}
	}
	return sys_inf.json_out_buf;
}
char *json_parse(char *pMsg)
{
	cJSON *pJson=NULL;
	if(NULL==pMsg)
	{ //ַΪ
		return "err_str_null";
	}
	pJson=cJSON_Parse(pMsg);
	if(NULL==pJson)
	{ //JSONʽ
		cJSON_Delete(pJson);
		return "err_josn_err";
	}
	if(strstr(cJSON_GetObjectItem(pJson,"pak_ty")->valuestring,"ack_inf")!=NULL)
	{ //ACK
		sys_inf.rtc_set_nian=cJSON_GetObjectItem(pJson,"nian")->valueint-2000; //
		sys_inf.rtc_set_yue=cJSON_GetObjectItem(pJson,"yue")->valueint;
		sys_inf.rtc_set_ri=cJSON_GetObjectItem(pJson,"ri")->valueint;
		sys_inf.rtc_set_shi=cJSON_GetObjectItem(pJson,"shi")->valueint;
		sys_inf.rtc_set_fen=cJSON_GetObjectItem(pJson,"fen")->valueint;
		sys_inf.rtc_set_miao=cJSON_GetObjectItem(pJson,"miao")->valueint;
		//set_inf.jg_cj_s=cJSON_GetObjectItem(pJson,"cj_s")->valueint; //
		//set_inf.jg_up_s=cJSON_GetObjectItem(pJson,"up_s")->valueint; //
		//set_inf.jg_xt_s=cJSON_GetObjectItem(pJson,"xt_s")->valueint; //
		if(1)
		{ //Ŵ

		}

		cJSON_Delete(pJson);
		return "ack_inf";
	}else if(strstr(cJSON_GetObjectItem(pJson,"pak_ty")->valuestring,"set_cmd")!=NULL)
	{ //ط
		if(strstr(cJSON_GetObjectItem(pJson,"pro_ty")->valuestring,sys_inf.dev_ty_str)!=NULL)
		{ //ط
		  //set_inf.dqf_stak=cJSON_GetObjectItem(pJson,"dqf_stak")->valueint;

			//sys_inf.dqf_stak=set_inf.dqf_stak;
			sys_inf.flash_set_flg=1;
			cJSON_Delete(pJson);
			return "rf_epct_dqf1ch";
		}else
		{
			cJSON_Delete(pJson);
			return "set_cmd?";
		}
		flash_set_sync('w');
		cJSON_Delete(pJson);
		return "set_cmd";
	}else
	{
		cJSON_Delete(pJson);
		return "cmd_err";
	}
	cJSON_Delete(pJson);
	return 0;
}
