/********************************** (C) COPYRIGHT *******************************
 * File Name          : ch32v20x_it.c
 * Author             : WCH
 * Version            : V1.0.0
 * Date               : 2021/06/06
 * Description        : Main Interrupt Service Routines.
*********************************************************************************
* Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
* Attention: This software (modified or not) and binary are used for
* microcontroller manufactured by Nanjing Qinheng Microelectronics.
*******************************************************************************/
#include "sys.h"




/*********************************************************************
 * @fn      NMI_Handler
 *
 * @brief   This function handles NMI exception.
 *
 * @return  none
 */
void NMI_Handler(void) __attribute__((interrupt()));
void NMI_Handler(void)
{
    GET_INT_SP();
    rt_interrupt_enter();

	while(1)
	{
		LED_PWR_R_H;
		LED_NET_R_H;
	}

    rt_interrupt_leave();
    FREE_INT_SP();
}

/*********************************************************************
 * @fn      HardFault_Handler
 *
 * @brief   This function handles Hard Fault exception.
 *
 * @return  none
 */
void HardFault_Handler(void) __attribute__((interrupt()));
void HardFault_Handler(void)
{
    GET_INT_SP();
    rt_interrupt_enter();

	while(1)
	{
		LED_PWR_R_H;
		LED_NET_R_H;
	}

    rt_interrupt_leave();
    FREE_INT_SP();

}

//void RTC_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));
//void RTC_IRQHandler(void)
//{
//
//	if(RTC_GetITStatus(RTC_IT_SEC)!=RESET)
//	{ //ж
//		RTC_ClearITPendingBit(RTC_IT_SEC);
//		////RTC_Get();
//		////sys_inf.cjS_val++;
//	}else if(RTC_GetITStatus(RTC_IT_OW)!=RESET)
//	{ //ж
//		RTC_ClearITPendingBit(RTC_IT_OW);
//		////RTC_Get();
//	}else if(RTC_GetITStatus(RTC_IT_ALR)!=RESET)
//	{ //ж=Ŀǰʹõ
//		RTC_ClearITPendingBit(RTC_IT_ALR);
//		sys_inf.rtc_wake_flg=1;
//		sys_inf.rtc_wake_buf=RTC_GetCounter()-1;
//		RTC_SetAlarm(sys_inf.rtc_wake_buf+def_wakeS);
//		//-------------------------------------------
//
//
//
//	}else
//	{ //δ֪RTCж
//		RTC_ClearITPendingBit(RTC_IT_SEC|RTC_IT_OW|RTC_IT_ALR);
//	}
//	RTC_WaitForLastTask();
//}

void RTCAlarm_IRQHandler(void) __attribute__((interrupt()));
void RTCAlarm_IRQHandler(void)
{
	GET_INT_SP();
	rt_interrupt_enter();

	sys_inf.rtc_wake_flg=1;
	EXTI_ClearITPendingBit(EXTI_Line17);
	RTC_ClearITPendingBit(RTC_IT_ALR);

	if(0)
	{ //
		if(sys_inf.mt1_jg_h >= def_wakeS)
		{ //ʱû
			sys_inf.mt1_jg_h -= def_wakeS;
		}else
		{ //=ؼ=õι=򿪹߳
			sys_inf.mt1_jg_h = set_inf.mt1_jg_h;
			sys_inf.mt1_zd_kg=1;

			if(sys_inf.mt1_stak_run_flg==0)
			{ //1߳
				rt_thread_resume(&motor1_thread);
			}
		}
		if(sys_inf.mt1_zd_kg==1)
		{ //һει
			if(sys_inf.mt1_gz_s>=def_wakeS)
			{ //ι
				sys_inf.mt1_gz_s-=def_wakeS;
			}else
			{ //ι=صιʱ
				sys_inf.mt1_gz_s=set_inf.mt1_gz_s;
				sys_inf.mt1_zd_kg=0;
			}
		}
	}
	if(0)
	{ //ұ
		if(sys_inf.mt2_jg_h >= def_wakeS)
		{ //ʱû
			sys_inf.mt2_jg_h -= def_wakeS;
		}else
		{ //=ؼ=õι=򿪹߳
			sys_inf.mt2_jg_h = set_inf.mt2_jg_h;
			sys_inf.mt2_zd_kg=1;

			if(sys_inf.mt2_stak_run_flg==0)
			{ //2߳
				rt_thread_resume(&motor2_thread);
			}
		}
		if(sys_inf.mt2_zd_kg==1)
		{ //һει
			if(sys_inf.mt2_gz_s>=def_wakeS)
			{ //ι
				sys_inf.mt2_gz_s-=def_wakeS;
			}else
			{ //ι=صιʱ
				sys_inf.mt2_gz_s=set_inf.mt2_gz_s;
				sys_inf.mt2_zd_kg=0;
			}
		}
	}


	rt_interrupt_leave();
	FREE_INT_SP();
}

void EXTI0_IRQHandler(void) __attribute__((interrupt()));
void EXTI0_IRQHandler(void)
{
	GET_INT_SP();
	rt_interrupt_enter();

	if(EXTI_GetITStatus(EXTI_Line0)!=RESET)
	{
		HAL_GPIO_EXTI_Callback(GPIO_Pin_0);
		EXTI_ClearITPendingBit(EXTI_Line0);
	}
	
	rt_interrupt_leave();
	FREE_INT_SP();
}

void EXTI1_IRQHandler(void) __attribute__((interrupt()));
void EXTI1_IRQHandler(void)
{
	GET_INT_SP();
	rt_interrupt_enter();

	if(EXTI_GetITStatus(EXTI_Line1)!=RESET)
	{
		HAL_GPIO_EXTI_Callback(GPIO_Pin_1);
		EXTI_ClearITPendingBit(EXTI_Line1);
	}

	rt_interrupt_leave();
	FREE_INT_SP();
}

void EXTI2_IRQHandler(void) __attribute__((interrupt()));
void EXTI2_IRQHandler(void)
{
	GET_INT_SP();
	rt_interrupt_enter();

	if(EXTI_GetITStatus(EXTI_Line2)!=RESET)
	{
		HAL_GPIO_EXTI_Callback(GPIO_Pin_2);
		EXTI_ClearITPendingBit(EXTI_Line2);
	}

	rt_interrupt_leave();
	FREE_INT_SP();
}

void EXTI3_IRQHandler(void) __attribute__((interrupt()));
void EXTI3_IRQHandler(void)
{
	GET_INT_SP();
	rt_interrupt_enter();

	if(EXTI_GetITStatus(EXTI_Line3)!=RESET)
	{
		HAL_GPIO_EXTI_Callback(GPIO_Pin_3);
		EXTI_ClearITPendingBit(EXTI_Line3);
	}

	rt_interrupt_leave();
	FREE_INT_SP();
}

void EXTI4_IRQHandler(void) __attribute__((interrupt()));
void EXTI4_IRQHandler(void)
{
	GET_INT_SP();
	rt_interrupt_enter();

	if(EXTI_GetITStatus(EXTI_Line4)!=RESET)
	{
		HAL_GPIO_EXTI_Callback(GPIO_Pin_4);
		EXTI_ClearITPendingBit(EXTI_Line4);
	}

	rt_interrupt_leave();
	FREE_INT_SP();
}

void EXTI9_5_IRQHandler(void) __attribute__((interrupt()));
void EXTI9_5_IRQHandler(void)
{
	GET_INT_SP();
	rt_interrupt_enter();

	if(EXTI_GetITStatus(EXTI_Line5)!=RESET)
	{ //
		HAL_GPIO_EXTI_Callback(GPIO_Pin_5);
		EXTI_ClearITPendingBit(EXTI_Line5);
	}
	if(EXTI_GetITStatus(EXTI_Line6)!=RESET)
	{ //
		HAL_GPIO_EXTI_Callback(GPIO_Pin_6);
		EXTI_ClearITPendingBit(EXTI_Line6);
	}
	if(EXTI_GetITStatus(EXTI_Line7)!=RESET)
	{ //
		HAL_GPIO_EXTI_Callback(GPIO_Pin_7);
		EXTI_ClearITPendingBit(EXTI_Line7);
	}
	if(EXTI_GetITStatus(EXTI_Line8)!=RESET)
	{ //
		HAL_GPIO_EXTI_Callback(GPIO_Pin_8);
		EXTI_ClearITPendingBit(EXTI_Line8);
	}
	if(EXTI_GetITStatus(EXTI_Line9)!=RESET)
	{ //
		HAL_GPIO_EXTI_Callback(GPIO_Pin_9);
		EXTI_ClearITPendingBit(EXTI_Line9);
	}

	rt_interrupt_leave();
	FREE_INT_SP();
}

void EXTI15_10_IRQHandler(void) __attribute__((interrupt()));
void EXTI15_10_IRQHandler(void)
{
	GET_INT_SP();
	rt_interrupt_enter();
	if(EXTI_GetITStatus(EXTI_Line10)!=RESET)
	{ //
		HAL_GPIO_EXTI_Callback(GPIO_Pin_10);
		EXTI_ClearITPendingBit(EXTI_Line10);
	}
	if(EXTI_GetITStatus(EXTI_Line11)!=RESET)
	{ //
		HAL_GPIO_EXTI_Callback(GPIO_Pin_11);
		EXTI_ClearITPendingBit(EXTI_Line11);
	}
	if(EXTI_GetITStatus(EXTI_Line12)!=RESET)
	{ //
		HAL_GPIO_EXTI_Callback(GPIO_Pin_12);
		EXTI_ClearITPendingBit(EXTI_Line12);
	}
	if(EXTI_GetITStatus(EXTI_Line13)!=RESET)
	{ //
		HAL_GPIO_EXTI_Callback(GPIO_Pin_13);
		EXTI_ClearITPendingBit(EXTI_Line13);
	}
	if(EXTI_GetITStatus(EXTI_Line14)!=RESET)
	{ //
		HAL_GPIO_EXTI_Callback(GPIO_Pin_14);
		EXTI_ClearITPendingBit(EXTI_Line14);
	}
	if(EXTI_GetITStatus(EXTI_Line15)!=RESET)
	{ //
		HAL_GPIO_EXTI_Callback(GPIO_Pin_15);
		EXTI_ClearITPendingBit(EXTI_Line15);
	}
	rt_interrupt_leave();
	FREE_INT_SP();
}
void HAL_GPIO_EXTI_Callback(uint16_t GPIO_Pin)
{
	if(GPIO_Pin==USB_IN_Pin)
	{ //USB-IN
		if(USB_IN==Bit_SET)
		{ //USB
			sys_inf.usb_in_flg=1;
			sys_inf.usb_in_wake_flg=1;
		}else
		{ //USBϿ
			sys_inf.usb_in_flg=0;
		}
	}
	if(GPIO_Pin==CD_OK_Pin)
	{ //CD-OK
		if(CD_OK_IN==Bit_RESET)
		{ //
			sys_inf.cd_ok_flg=1;
		}else
		{ //
			sys_inf.cd_ok_flg=0;
		}
	}
	if(GPIO_Pin==CD_FLG_Pin)
	{ //CD-FLG
		if(CD_FLG_IN==Bit_RESET)
		{ //ڳ
			sys_inf.cd_flg_flg=1;
		}else
		{ //
			sys_inf.cd_flg_flg=0;
		}
	}
	if(GPIO_Pin==KEY1_Pin)
	{ //KEY1=
		if(KEY1_IN==Bit_RESET)
		{ //
			sys_inf.beep_ms=50;
			if(sys_inf.set_mode_flg==1)
			{//ģʽ=λ
				if(sys_inf.set_wei_val<10)
				{
					sys_inf.set_wei_val++;
				}			
			}else
			{//ڹģʽ=Bֶͣ
				sys_inf.mt2_sd_kg=!sys_inf.mt2_sd_kg;
			}
		}else
		{ //̧

		}
	}
	if(GPIO_Pin==KEY2_Pin)
	{ //KEY2=
		if(KEY2_IN==Bit_RESET)
		{ //
			sys_inf.beep_ms=50;
			if(sys_inf.set_mode_flg==1)
			{//ģʽ=ֵ
				if(set_inf.mtx_buf[sys_inf.set_wei_val]<10)
				{
					set_inf.mtx_buf[sys_inf.set_wei_val]++;
				}				
			}else
			{//ڹģʽ=
				
			}
		}else
		{ //̧

		}
	}
	if(GPIO_Pin==KEY3_Pin)
	{ //KEY3=
		if(KEY3_IN==Bit_RESET)
		{ //
			sys_inf.beep_ms=50;
			if(sys_inf.set_mode_flg==1)
			{//ȥģʽ=õĲ
				sys_inf.set_mode_flg=0;
				sys_inf.flash_set_flg=1;
			}else
			{//ȥģʽ
				sys_inf.set_mode_flg=1;
			}
		}else
		{ //̧

		}
	}
	if(GPIO_Pin==KEY4_Pin)
	{ //KEY4=
		if(KEY4_IN==Bit_RESET)
		{ //
			sys_inf.beep_ms=50;
			if(sys_inf.set_mode_flg==1)
			{//ģʽ=λ
				if(sys_inf.set_wei_val>0)
				{
					sys_inf.set_wei_val--;
				}			
			}else
			{//ڹģʽ=Aֶͣ
				sys_inf.mt1_sd_kg=!sys_inf.mt1_sd_kg;
			}
		}else
		{ //̧

		}
	}
	if(GPIO_Pin==KEY5_Pin)
	{ //KEY5=
		if(KEY5_IN==Bit_RESET)
		{ //
			sys_inf.beep_ms=50;
			if(sys_inf.set_mode_flg==1)
			{//ģʽ=ֵ
				if(set_inf.mtx_buf[sys_inf.set_wei_val]>0)
				{
					set_inf.mtx_buf[sys_inf.set_wei_val]--;
				}				
			}else
			{//ڹģʽ=
				
			}
		}else
		{ //̧

		}
	}
}

void USART1_IRQHandler(void) __attribute__((interrupt()));
void USART1_IRQHandler(void)
{
	if(USART_GetITStatus(USART1,USART_IT_RXNE)!=RESET)
	{
		sys_inf.wibl_rx_data=USART_ReceiveData(USART1);
		if(sys_inf.wibl_rx_wei<0xFF)
		{
			sys_inf.wibl_rx_buf[sys_inf.wibl_rx_wei]=sys_inf.wibl_rx_data;
			sys_inf.wibl_rx_wei++;
		}else
		{
			sys_inf.wibl_rx_wei=0;
		}
	}
	USART_ClearITPendingBit(USART1,USART_IT_RXNE); //жϱ־
}

void USART2_IRQHandler(void) __attribute__((interrupt()));
void USART2_IRQHandler(void)
{
	if(USART_GetITStatus(USART2,USART_IT_RXNE)!=RESET)
	{
//        sys_inf.rs4851_rx_data=USART_ReceiveData(USART2);
//        if(sys_inf.rs4851_rx_wei<0xFF)
//        {
//            sys_inf.rs4851_rx_buf[sys_inf.rs4851_rx_wei]=sys_inf.rs4851_rx_data;
//            sys_inf.rs4851_rx_wei++;
//        }else
//        {
//            sys_inf.rs4851_rx_wei=0;
//        }
	}
	USART_ClearITPendingBit(USART2,USART_IT_RXNE); //жϱ־
}

void USART3_IRQHandler(void) __attribute__((interrupt()));
void USART3_IRQHandler(void)
{
	if(USART_GetITStatus(USART3,USART_IT_RXNE)!=RESET)
	{
//        sys_inf.rs4851_rx_data=USART_ReceiveData(USART2);
//        if(sys_inf.rs4851_rx_wei<0xFF)
//        {
//            sys_inf.rs4851_rx_buf[sys_inf.rs4851_rx_wei]=sys_inf.rs4851_rx_data;
//            sys_inf.rs4851_rx_wei++;
//        }else
//        {
//            sys_inf.rs4851_rx_wei=0;
//        }
	}
	USART_ClearITPendingBit(USART3,USART_IT_RXNE); //жϱ־
}

